Subject: Re: bug#78785: 29.3; docs: switch-to-prev-buffer-skip is hard to find

From: Stéphane Marks <[email-masked]>
Date: Mon, 16 Jun 2025 12:35:30 -0400

On Mon, Jun 16, 2025 at 11:51 AM martin rudalics via Bug reports for GNU
Emacs, the Swiss army knife of text editors <[email-masked]> wrote:

>  > There are two related, but different behaviors here, which both happen
>  > when the current buffer is killed:
>  >
>  >    . which buffer becomes the current one, and
>  >    . which buffer replaces the current buffer in its window
>  >
>  > The manual's documentation of the behavior of kill-buffer which you
>  > quote talks about the former, whereas switch-to-prev-buffer-skip
>  > affects the latter.
>
> Indeed.  By virtue of the fact that the command loop makes the selected
> window's buffer current, a user gets the impression that these are one
> and the same.
>
>  > So I don't see a problem in the documentation, and AFAIU the
>  > correction you suggested for the manual is incorrect, because it
>  > wrongly conflates these two subtly different behaviors.
>
> We could say
>
>    If you kill the current buffer, Emacs makes another buffer current and
>    either shows another buffer in every window showing the old current
>    buffer or deletes such a window.  If you are not satisfied with that
>    behavior, try customizing the options `kill-buffer-quit-windows'
>    and/or `switch-to-prev-buffer-skip'.  In either case, the command loop
>    will eventually make the now selected window's buffer current.
>
> instead.
>

If you're a tab-bar user, there's also this user option
`tab-bar-select-restore-windows` to take a look at.